"use strict";

var storage = localStorage;

class FileIO {
    constructor()
    {
        this.clear();
        storage.setItem("crypt.txt", 
        "pyeb cmybo kxn cofox iokbc kqy yeb pkdrobc lbyeqrd pybdr yx drsc myxdsxoxd, k xog xkdsyx, myxmosfon sx vslobdi, kxn nonsmkdon dy dro zbyzycsdsyx drkd kvv wox kbo mbokdon oaekv.\n" +
        "xyg go kbo oxqkqon sx k qbokd msfsv gkb, docdsxq grodrob drkd xkdsyx, yb kxi xkdsyx cy myxmosfon kxn cy nonsmkdon, mkx vyxq oxnebo. go kbo wod yx k qbokd lkddvo-psovn yp drkd gkb. go rkfo mywo dy nonsmkdo k zybdsyx yp drkd psovn, kc k psxkv bocdsxq zvkmo pyb dryco gry robo qkfo drosb vsfoc drkd drkd xkdsyx wsqrd vsfo. sd sc kvdyqodrob psddsxq kxn zbyzob drkd go cryevn ny drsc.\n" + 
        "led, sx k vkbqob coxco, go mkx xyd nonsmkdo -- go mkx xyd myxcombkdo -- go mkx xyd rkvvyg -- drsc qbyexn. dro lbkfo wox, vsfsxq kxn nokn, gry cdbeqqvon robo, rkfo myxcombkdon sd, pkb klyfo yeb zyyb zygob dy knn yb nodbkmd. dro gybvn gsvv vsddvo xydo, xyb vyxq bowowlob grkd go cki robo, led sd mkx xofob pybqod grkd droi nsn robo. sd sc pyb ec dro vsfsxq, bkdrob, dy lo nonsmkdon robo dy dro expsxscron gybu grsmr droi gry pyeqrd robo rkfo drec pkb cy xylvi knfkxmon. sd sc bkdrob pyb ec dy lo robo nonsmkdon dy dro qbokd dkcu bowksxsxq lopybo ec -- drkd pbyw droco ryxybon nokn go dkuo sxmbokcon nofydsyx dy drkd mkeco pyb grsmr droi qkfo dro vkcd pevv wokcebo yp nofydsyx -- drkd go robo rsqrvi bocyvfo drkd droco nokn crkvv xyd rkfo nson sx fksx -- drkd drsc xkdsyx, exnob qyn, crkvv rkfo k xog lsbdr yp pboonyw -- kxn drkd qyfobxwoxd yp dro zoyzvo, li dro zoyzvo, pyb dro zoyzvo, crkvv xyd zobscr pbyw dro okbdr.\n"
        );        
    }
    clear()
    {
        this.files = [];
    }
    all_close()
    {
        for(var i = 0; i < this.files.length; i++)
        {
            try{
                if(this.files[n].mode == "r") this.close(i);
            }
            catch(e)
            {
                return false;
            }
            this.files[n] = null;
        }
        return true;
    }
    openr(filename)
    {
        var value = storage.getItem(filename);
        if(value)
        {
            this.files.push({
                "name": filename,
                "val" : value,
                "pos" : 0,
                "mode": "r"
            });
            return this.files.length - 1;
        }
        return -1;
    }
    openw(filename)
    {
        this.files.push({
            "name": filename,
            "val" : "",
            "pos" : 0,
            "mode": "w"
        });
        return this.files.length - 1;
    }
    opena(filename)
    {
        var value = storage.getItem(filename);
        var str = value ? value : "";
        this.files.push({
            "name": filename,
            "val" : str,
            "pos" : str.length,
            "mode": "w"
        });
        return this.files.length - 1;
    }
    close(n)
    {
        if(n >= 0 && n < this.files.length)
        {
            if(this.files[n])
            {
                if(this.files[n].mode == "w")
                {
                    try{
                        storage.setItem(this.files[n].name, this.files[n].val);
                    }
                    catch(e)
                    {
                        this.files[n] = null;
                        return false;
                    }
                }
            }
            this.files[n] = null;
            return true;
        }
        else return false;
    }
    read_line(n)
    {
        if(n < 0 || n >= this.files.length || this.files[n] == null) return null;
        if(this.files[n].pos >= this.files[n].val.length) return "";
        var re = /([^\r\n]*)(\r\n|\r|\n)/;
        var substr = this.files[n].val.substring(this.files[n].pos)
        var res = re.exec(substr);
        if(res)
        {
            this.files[n].pos += res[1].length + res[2].length;
            return res[0];
        }
        else{
            this.files[n].pos += substr.length;
            return substr;
        }
    }
    read_ch(n)
    {
        if(n < 0 || n >= this.files.length || this.files[n] == null) return null;
        if(this.files[n].pos >= this.files[n].val.length) return "";
        return this.files[n].val[this.files[n].pos++];
    }
    write_str(n, str, newline)
    {
        if(n < 0 || n >= this.files.length || this.files[n] == null) return false;
        if(this.files[n].mode == "w")
        {
            this.files[n].val += str + (newline ? "\n" : "");
            return true;
        }
        else return false;
    }
};

var filesystem = new FileIO();
